#include <stdio.h>
#include <ctype.h>

char *sccsid = "@(#)to-koi8.c	1.1 10/31/91" ;

char *cyrllic = "#$@[\\]^_`{|}~" ; /* spec. chars used for cyrillic */

main (argc, argv)
/*
 *  Set eighth bit on everything between /+ and /-
 *  Remove the /+ and /- from the data stream
 *
 *  Usage: to-koi8 [file [file ...] ]
 *
 *  Use stdin if no files are named.
 *  Always writes to stdout.
 *
 *  This code should be modified to enable some way of included
 *  /+ and /- in the text if necessary.
 */
	int	argc ;
	char	**argv ;
{
	FILE	*fp ;
	int	ix ;

	ix = 1 ;
	do {
		if (ix >= argc)
			fp = stdin ;
		else
		{
			if ( (fp = fopen (argv[ix], "r") ) == (FILE*)0)
			{
				perror (argv[ix]) ;
				return (-1) ;
			}
		}

		Convert (fp) ;
	} while (++ix < argc) ;

	return (0) ;
}


Convert (fp)
	FILE	*fp ;
{
	int	ch  ;
	int	flag = 0 ;

	while ( (ch = fgetc (fp) ) != EOF)
	{
		if (ch == '/')
		{
			if ( (ch = fgetc (fp) ) == '-')
			{
				flag = 0 ;
			}
			else if (ch == '+')
				flag = 1 ;
			else
			{
				ungetc(ch, fp) ;
				putchar ('/') ;
			}
		}
		else if (flag)
		{
			if (isalpha(ch) || strchr (cyrllic, ch) )
				putchar (ch | 0x80) ;
			else
				putchar (ch) ;
		}
		else
			putchar (ch) ;

	}

	return (0) ;
}
